<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
<!-- creating-plugins.qdoc -->
  <title>Creating Plugins | Extending Qt Creator Manual</title>
  <link rel="stylesheet" type="text/css" href="style/offline-simple.css" />
  <script type="text/javascript">
    document.getElementsByTagName("link").item(0).setAttribute("href", "style/offline.css");
    // loading style sheet breaks anchors that were jumped to before
    // so force jumping to anchor again
    setTimeout(function() {
        var anchor = location.hash;
        // need to jump to different anchor first (e.g. none)
        location.hash = "#";
        setTimeout(function() {
            location.hash = anchor;
        }, 0);
    }, 0);
  </script>
</head>
<body>
<div class="header" id="qtdocheader">
  <div class="main">
    <div class="main-rounded">
      <div class="navigationbar">
        <table><tr>
<td ><a href="extending-index.html">Extending Qt Creator Manual</a></td><td >Creating Plugins</td></tr></table><table class="buildversion"><tr>
<td id="buildversion" width="100%" align="right"><a href="extending-index.html">Extending Qt Creator Manual 4.11.1</a></td>
        </tr></table>
      </div>
    </div>
<div class="content">
<div class="line">
<div class="content mainContent">
<div class="sidebar">
<div class="toc">
<h3><a name="toc">Contents</a></h3>
<ul>
<li class="level1"><a href="#basics">Basics</a></li>
<li class="level1"><a href="#design-principles">Design Principles</a></li>
<li class="level1"><a href="#creating-3rd-party-plugins">Creating 3rd-Party Plugins</a></li>
</ul>
</div>
<div class="sidebar-content" id="sidebar-content"></div></div>
<h1 class="title">Creating Plugins</h1>
<span class="subtitle"></span>
<!-- $$$creating-plugins.html-description -->
<div class="descr"> <a name="details"></a>
<p>At its very core, Qt Creator consists of a plugin loader that loads and runs a set of plugins, which then actually provide the functionality that you know from Qt Creator the IDE. So, even the main application window and menus are all provided by plugins. Plugins can use different means to provide other plugins access to their functionality and to allow them to extend certain aspects of the application.</p>
<p>For example the <code>Core</code> plugin, which is the very basic plugin that must be present for Qt Creator to run at all, provides the main window itself, and API for adding menu items, modes, editor types, navigation panels and many other things.</p>
<p>The <code>TextEditor</code> plugin provides a framework and base implementation for different text editors with highlighting, completion and folding, that is then used by other plugins to add more specialized text editor types to Qt Creator, like for editing C/C++ or <code>.pro</code> files.</p>
<p>After reading this guide you will know what a basic plugin consists of, how to write a plugin specification file, what the lifecycle of a plugin is, what the general principles for extending existing plugins' functionality and providing interfaces for other plugins are, and will be able to write your first plugin.</p>
<a name="basics"></a>
<h2 id="basics">Basics</h2>
<ul>
<li><a href="getting-and-building.html">Getting and Building Qt Creator</a></li>
<li><a href="first-plugin.html">Creating Your First Plugin</a></li>
<li><a href="plugin-meta-data.html">Plugin Meta Data</a></li>
<li><a href="plugin-lifecycle.html">Plugin Life Cycle</a></li>
</ul>
<a name="design-principles"></a>
<h2 id="design-principles">Design Principles</h2>
<ul>
<li><a href="pluginmanager.html">The Plugin Manager, the Object Pool, and Registered Objects</a></li>
<li>Aggregations</li>
<li>Extending and Providing Interfaces</li>
</ul>
<a name="creating-3rd-party-plugins"></a>
<h2 id="creating-3rd-party-plugins">Creating 3rd-Party Plugins</h2>
<ul>
<li>A Note on Binary Compatibility</li>
<li>Creating User-Installable Plugins</li>
</ul>
</div>
<!-- @@@creating-plugins.html -->
        </div>
       </div>
   </div>
   </div>
</div>
<div class="footer">
   <p>
   <acronym title="Copyright">&copy;</acronym> 2020 The Qt Company Ltd.
   Documentation contributions included herein are the copyrights of
   their respective owners.<br/>    The documentation provided herein is licensed under the terms of the    <a href="http://www.gnu.org/licenses/fdl.html">GNU Free Documentation    License version 1.3</a> as published by the Free Software Foundation.<br/>    Qt and respective logos are trademarks of The Qt Company Ltd.     in Finland and/or other countries worldwide. All other trademarks are property
   of their respective owners. </p>
</div>
</body>
</html>
